#ifndef CARD_H
#define CARD_H

#include <QString>
#include <QStringList>
#include <QDebug>
#include <QTableWidgetItem>
#include <QVector>
#include <QLabel>
#include <QDebug>

const QString ManaSymbolWhite = "🔆";
const QString ManaSymbolRed = "🔥";
const QString ManaSymbolBlue = "💧";
const QString ManaSymbolBlack = "💀";
const QString ManaSymbolGreen = "🌳";

class Card
{
public:
    Card(const QString _name, const QString _cost, const QString _colors, const QStringList _types, const QString _edition, const QString _rarity, const QString _text, const QString _flavor, const QString _power, const QString _life);
    Card(const QString _name, const QString _cost, const QString _colors, const QStringList _types, const QString _edition, const QString _rarity, const QString _text, const QString _flavor, const QString _power, const QString _life, short _standard, short _modern, short _commander);
    //QString hidden_cost;
    //QString converted_cost;

    inline QString get_name() const
    {
        return name;
    }
    inline QString get_cost() const
    {
        return cost;
    }
    inline QString get_edition() const
    {
        return edition;
    }
    inline QString get_text() const
    {
        return text;
    }
    inline QString get_flavor() const
    {
        return flavor;
    }
    inline QString get_colors() const
    {
        return colors;
    }
    inline QString get_rarity() const
    {
        return rarity;
    }
    inline QStringList get_types() const
    {
        return types;
    }
    inline QString get_power() const
    {
        return power;
    }
    inline QString get_life() const
    {
        return life;
    }
    inline QString get_original_text() const
    {
        return original_text;
    }
    inline QString get_original_cost() const
    {
        return original_cost;
    }
    inline int get_converted_cost() const
    {
        return converted_cost;
    }

    inline short get_legal_commander() const
    {
        return legal_commander;
    }
    inline short get_legal_modern() const
    {
        return legal_modern;
    }
    inline short get_legal_standard() const
    {
        return legal_standard;
    }

    operator QString() const;
    bool operator ==(const QString& _name) const;
    QVector<QTableWidgetItem *> getTableItems() const;
    bool init_done = false;

private:

    void createTableItems();
    void createSymbolsFromText();
    void calculateConvertedCost();
    int calculateConvertedCost(const QString& _text);
    void replaceFormatChars();

    Card();

    QString name;
    QString cost;
    QString edition;
    QString text;
    QString flavor;
    QString colors;
    QString rarity;
    QStringList types;
    QString power;
    QString life;
    QString original_text;
    QString original_cost;
    QString type_string;
    int converted_cost;
    short legal_commander = -1;
    short legal_modern = -1;
    short legal_standard = -1;

};



#endif // CARD_H
